Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_model.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_model.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_model.cpp	(revision 88)
@@ -9,4 +9,5 @@
 
 #include "Behavioural/include/Vhdl.h"
+#include "Common/include/Environment.h"
 #include <sstream>
 #include <fstream>
@@ -19,8 +20,9 @@
     log_printf(FUNC,Behavioural,"generate_file_model","Begin");
 
-    std::string filename = _name + ".vhdl";
+    directory();
+
+    std::string filename = MORPHEO_VHDL + "/" + _name + ".vhdl";
     
-    log_printf(TRACE,Behavioural,"generate_file_model","print %s",filename.c_str());
-    std::cout << "Generate file \""<< filename << "\"" << std::endl;
+    msg_printf(INFORMATION,_("Generate file \"%s\"."),filename.c_str());
 
     log_printf(TRACE,Behavioural,"generate_file_model","declaration");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_package.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_package.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_generate_file_package.cpp	(revision 88)
@@ -9,4 +9,5 @@
 
 #include "Behavioural/include/Vhdl.h"
+#include "Common/include/Environment.h"
 #include <sstream>
 #include <fstream>
@@ -19,8 +20,10 @@
     log_printf(FUNC,Behavioural,"generate_file_package","Begin");
 
+    directory();
+
     std::string name     = _name + "_Pack";
-    std::string filename =  name + ".vhdl";
+    std::string filename = MORPHEO_VHDL + "/" + name + ".vhdl";
 
-    std::cout << "Generate file \""<< filename << "\"" << std::endl;
+    msg_printf(INFORMATION,_("Generate file \"%s\"."),filename.c_str());
 
     std::ofstream file;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_set_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_set_body.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_set_body.cpp	(revision 88)
@@ -17,8 +17,22 @@
 #undef  FUNCTION
 #define FUNCTION "Vhdl::set_body"
-  void Vhdl::set_body (std::string      text     )
+  void Vhdl::set_body (std::string text)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
     set_list(_list_body, text);
+    log_printf(FUNC,Behavioural,FUNCTION,"End");
+  };
+  
+#undef  FUNCTION
+#define FUNCTION "Vhdl::set_body"
+  void Vhdl::set_body (Vhdl * vhdl)
+  {
+    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+    
+    for (std::list<std::string>::iterator it=vhdl->_list_body.begin();
+         it!=vhdl->_list_body.end();
+         ++it)
+      set_list(_list_body, *it);
+
     log_printf(FUNC,Behavioural,FUNCTION,"End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML.cpp	(revision 88)
@@ -17,5 +17,5 @@
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
-    _filename_extension="xml";
+    _filename_extension=".xml";
     log_printf(FUNC,Behavioural,FUNCTION,"End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XMLLightFunctors.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XMLLightFunctors.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XMLLightFunctors.cpp	(revision 88)
@@ -0,0 +1,42 @@
+#include "Behavioural/include/XMLLightFunctors.h"
+
+using namespace morpheo::XMLUtils; 
+using namespace std;
+
+	//****************************XMLLightComparator method implementation*****************************//
+	
+		// the comparator functor used within parsing algorithm.
+
+		bool XMLLightComparator::operator() ( char firstChar, char secondChar ) {
+			static unsigned int counter = 0; 
+			static bool  searchForEndTag = false;
+
+			if ( searchForEndTag ) {
+				if ( secondChar == END_TAG ) {
+					searchForEndTag = false;
+					return true;
+				}
+				return false;
+			}
+
+			if   
+			( ( firstChar == BEGIN_TAG && secondChar == SECOND_TAG ) ||
+	     		( firstChar == SECOND_TAG && secondChar == END_TAG ) ) {
+				 --counter;
+				if ( ! counter ) {
+					if( firstChar == SECOND_TAG ) {
+						return true; 
+					}
+					searchForEndTag = true;
+					return false;
+				}			
+				return false;
+			}
+			else if ( firstChar == BEGIN_TAG ) {
+				counter++; 
+				return false; 
+			}
+			else {
+				return false; 
+			}
+		}		
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_generate_file.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_generate_file.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_generate_file.cpp	(revision 88)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/include/XML.h"
+#include "Common/include/ErrorMorpheo.h"
 #include <fstream>
 
@@ -14,5 +15,5 @@
 #undef  FUNCTION
 #define FUNCTION "XML::generate_file"
-  void XML::generate_file (std::string encoding)
+  void XML::generate_file (std::string dirname, std::string encoding)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
@@ -20,10 +21,13 @@
     header (encoding);
 
-    std::string filename =  _name + "." + _filename_extension;
+    std::string filename = dirname + "/" + _name + _filename_extension;
 
-    std::cout << "Generate file \""<< filename << "\"" << std::endl;
+    msg_printf(INFORMATION,_("Generate file \"%s\"."),filename.c_str());
 
     std::ofstream file;
-    file.open(filename.c_str(),std::ios::out | std::ios::trunc);
+    file.open(filename.c_str() ,std::ios::out | std::ios::trunc);
+
+    if (!file)
+      throw ERRORMORPHEO(FUNCTION,toString(_("Error opening \"%s\" file.\n"),filename.c_str()));
 
     file << get_body();
@@ -34,8 +38,8 @@
   };
 
-  void XML::generate_file (void)
+  void XML::generate_file (std::string dirname)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
-    generate_file("UTF-8");
+    generate_file(dirname,"UTF-8");
     log_printf(FUNC,Behavioural,FUNCTION,"End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_get_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_get_body.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_get_body.cpp	(revision 88)
@@ -24,10 +24,10 @@
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
 
-    std::string body       = _body;
-    std::string tabulation = indent(depth);
+    std::string body = _body;
+    std::string tab  = indent(depth);
 
-//  body.insert(0,tabulation);
+    body.insert(0,tab);
     for (size_t pos=body.find('\n',0); (pos<body.length()-1); pos=body.find('\n',++pos))
-      body.insert(++pos,tabulation);
+      body.insert(++pos,tab);
 
     log_printf(FUNC,Behavioural,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_insert_XML.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_insert_XML.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_insert_XML.cpp	(revision 88)
@@ -13,9 +13,9 @@
 #undef  FUNCTION
 #define FUNCTION "XML::insert_XML"
-  bool XML::insert_XML (XML xml)
+  bool XML::insert_XML (XML xml, uint32_t offset_depth)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
     //return text (xml.get_body());
-    _body += xml.get_body(depth());
+    _body += xml.get_body(depth()+offset_depth);
     log_printf(FUNC,Behavioural,FUNCTION,"End");
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_text.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_text.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/XML_text.cpp	(revision 88)
@@ -16,5 +16,5 @@
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
-    _body += indent()+text; // +"\n";
+    _body += text; // +"\n";
     log_printf(FUNC,Behavioural,FUNCTION,"End");
 
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Address.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Address.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Address.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Address
-#define morpheo_Address
+#ifndef Morpheo_Address_h
+#define Morpheo_Address_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Average.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Average.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Average.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Average
-#define morpheo_Average
+#ifndef Morpheo_Average_h
+#define Morpheo_Average_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/BitManipulation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/BitManipulation.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/BitManipulation.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_BitManipulation
-#define morpheo_BitManipulation
+#ifndef Morpheo_BitManipulation_h
+#define Morpheo_BitManipulation_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/ChangeCase.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/ChangeCase.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/ChangeCase.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_changecase
-#define morpheo_changecase
+#ifndef Morpheo_ChangeCase_h
+#define Morpheo_ChangeCase_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef DEBUG_H
-#define DEBUG_H
+#ifndef Morpheo_Debug_h
+#define Morpheo_Debug_h
 
 /*
@@ -13,4 +13,6 @@
  *  - log_begin
  *  - log_end
+ *  - log_function
+ *  - msg_print
  *  - breakpoint
  *
@@ -25,5 +27,5 @@
 #include "Common/include/Message.h"
 #include "Behavioural/include/Debug_component.h"
-#include "Behavioural/include/Environment.h"
+#include <systemc.h>
 #include <stdio.h>
 #include <string.h>
@@ -31,4 +33,6 @@
 #include <sstream>
 #include <string>
+
+namespace morpheo {
 
 enum _debug_verbosity 
@@ -54,7 +58,16 @@
 	   ( DEBUG_ ## component == true )) )				\
 	{								\
+	  if (DEBUG_ ## level <= DEBUG_INFO)				\
+	    {								\
+              msg("%s ",MSG_INFORMATION);                               \
+	    }								\
+          else                                                          \
+	    {								\
+              msg("%s ",MSG_DEBUG);                                     \
+	    }								\
+                                                                        \
 	  if (DEBUG >= DEBUG_FUNC)					\
 	    {								\
-	      msg(_("%s"),debug_tab().c_str());				\
+	      msg("%s",debug_tab().c_str());		                \
 	    }								\
 	  if (DEBUG >= DEBUG_ALL )					\
@@ -72,12 +85,11 @@
 	  if (DEBUG >= DEBUG_FUNC)					\
 	    {								\
-	      msg(_("<%s> "),func);					\
-	      msg(_("In file %s, "),__FILE__);				\
-	      msg(_("at line %d " ),__LINE__);				\
-	      msg(_(": "));						\
-	    }								\
-	  msg(str);							\
-	  msg(_("\n"));							\
-	  fflush (stdout);						\
+	      msg(  "<%s> " ,func);			        	\
+	      msg(_("In file %s, "),__FILE__);		        	\
+	      msg(_("at line %d " ),__LINE__);		        	\
+	      msg(  ": " );				        	\
+	    }						        	\
+	  msg(str);					        	\
+	  msg("\n");					        	\
 	}								\
     } while(0)
@@ -87,5 +99,5 @@
     {									\
       debug_tab_inc ();							\
-      log_printf(FUNC,component,func,"Begin");				\
+      log_printf(FUNC,component,func,_("Begin"));                       \
     } while(0)
 
@@ -93,5 +105,5 @@
   do									\
     {									\
-      log_printf(FUNC,component,func,"End");				\
+      log_printf(FUNC,component,func,_("End"));				\
       debug_tab_dec ();							\
     } while(0)
@@ -115,9 +127,30 @@
 #endif // DEBUG
 
+# define log_function(component,func,name)                              \
+  do									\
+    {									\
+      log_printf(TRACE,component,func,_("[%d] %s.%s"),static_cast<uint32_t>(sc_simulation_time()),name,func); \
+    } while(0)
+
+
+#define msg_printf(type,str...)                                         \
+  do                                                                    \
+    {                                                                   \
+      msg("%s ",MSG_ ## type);                                          \
+      msg(str);								\
+      msg("\n");							\
+    } while(0)
+
+
 #define breakpoint(str...)						\
   do									\
     {									\
-      msg(_("Breakpoint : file %s, line %d. Enter Any key to continue\n"),__FILE__,__LINE__); \
-      msg(str);								\
+      fprintf(stdout,_("%s "),MSG_BREAKPOINT);                                     \
+      fprintf(stdout,_("Breakpoint in file %s, line %d.\n"),__FILE__,__LINE__);    \
+      fprintf(stdout,_("%s "),MSG_NONE);                                           \
+      fprintf(stdout,str);								\
+      fprintf(stdout,_("\n"));                                                     \
+      fprintf(stdout,_("%s "),MSG_NONE);                                           \
+      fprintf(stdout,_("Enter any key to continue\n"));                            \
       getchar();							\
     } while(0)
@@ -128,5 +161,5 @@
     {									\
       if (x == NULL)							\
-	err(_("%s File %s, Line %d, this pointeur is null\n"),MSG_ERROR,__FILE__,__LINE__); \
+	err(_("File %s, Line %d, this pointeur is null\n"),__FILE__,__LINE__); \
     }									\
   while (0)
@@ -139,4 +172,4 @@
 #endif
 
-
+}; // end namespace morpheo
 #endif // !DEBUG_H
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Environment.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Environment.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Environment.h	(revision 88)
@@ -0,0 +1,62 @@
+#ifndef Morpheo_Environment_h
+#define Morpheo_Environment_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include <string>
+
+namespace morpheo {
+
+#if (defined(STATISTICS) and not defined(SYSTEMC))
+#  error "To have the statistics, you must set flags SYSTEMC"
+#endif
+
+#if (defined(INFORMATION) and not defined(STATISTICS))
+#  error "To have the information, you must set flags STATISTICS"
+#endif
+
+#if (defined(VHDL_TESTBENCH) and not defined(SYSTEMC))
+#  error "To have the vhdl's test bench, you must set flags SYSTEMC"
+#endif
+
+#if (defined(VHDL_TESTBENCH) and not defined(VHDL))
+#  error "To have the vhdl's test bench, you must set flags VHDL"
+#endif
+
+#if (defined(VHDL_TESTBENCH_ASSERT) and not defined(VHDL_TESTBENCH))
+#  error "To have an assert in vhdl's test bench, you must set flags VHDL_TESTBENCH"
+#endif
+
+#if (defined(VHDL_TESTBENCH) and defined(SYSTEMC))
+#  define SYSTEMC_VHDL_COMPATIBILITY
+#endif
+
+#if (defined(DEBUG))
+#  define DEBUG_TEST
+#endif
+
+  // Environment variable
+  extern std::string MORPHEO_HOME;
+  extern std::string MORPHEO_TOPLEVEL;
+  
+  void environment (void);
+  
+  extern std::string MORPHEO_STATISTICS;
+  extern std::string MORPHEO_VHDL;
+  extern std::string MORPHEO_POSITION;
+  extern std::string MORPHEO_LOG;
+  
+  void directory      (void);
+  void directory_init (std::string MORPHEO_STATISTICS =".",
+                       std::string MORPHEO_VHDL       =".",
+                       std::string MORPHEO_POSITION   =".",
+                       std::string MORPHEO_LOG        =".");
+
+}; // end namespace morpheo
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_ErrorMorpheo
-#define morpheo_ErrorMorpheo
+#ifndef Morpheo_ErrorMorpheo_h
+#define Morpheo_ErrorMorpheo_h
 
 /*
@@ -9,5 +9,8 @@
  */
 
-#include "ToString.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Translation.h"
+#include "Common/include/Message.h"
+
 #include <iostream>
 #include <exception>
@@ -23,6 +26,6 @@
     
     // -----[ methods ]---------------------------------------------------
-  public  :             ErrorMorpheo  ()                throw() {_msg="Exception detected ...";}
-  public  :             ErrorMorpheo  (std::string msg) throw() {_msg=msg;}
+  public  :             ErrorMorpheo  ()                throw() {_msg = toString("%s ",MSG_ERROR); _msg+="Exception detected ...";}
+  public  :             ErrorMorpheo  (std::string msg) throw() {_msg = toString("%s ",MSG_ERROR); _msg+=msg;}
   public  :             ErrorMorpheo  (std::string funcname,
 				       std::string msg     ,
@@ -30,5 +33,9 @@
 				       std::string file    ) throw() 
     { 
-      _msg = toString("<%s> at line %d, in file %s : %s",funcname.c_str(),line,file.c_str(),msg.c_str());
+#ifdef DEBUG
+      _msg = toString(_("%s <%s> at line %d, in file %s : %s"),MSG_ERROR,funcname.c_str(),line,file.c_str(),msg.c_str());
+#else
+      _msg = toString(_("%s %s"),MSG_ERROR,msg.c_str());
+#endif
     }
   public  :             ~ErrorMorpheo (void)       throw() {}
@@ -43,5 +50,5 @@
     
     // -----[ methods ]---------------------------------------------------
-  public  :             TestMorpheo   ()                throw() {_msg="Test error ...";}
+  public  :             TestMorpheo   ()                throw() {_msg=_("Test error ...");}
   public  :             TestMorpheo   (std::string msg) throw() {_msg=msg;}
   public  :             ~TestMorpheo  (void)            throw() {}
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/FromString.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/FromString.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/FromString.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_fromstring
-#define morpheo_fromstring
+#ifndef Morpheo_FromString_h
+#define Morpheo_FromString_h
 
 /*
@@ -27,4 +27,14 @@
   }
 
+  template<>           inline uint64_t fromString<uint64_t>   (const std::string& x)
+  {
+    return static_cast<uint64_t>(atoll(x.c_str()));
+  }
+
+  template<>           inline double   fromString<double>     (const std::string& x)
+  {
+    return static_cast<double>(atof(x.c_str()));
+  }
+
   template<>           inline bool     fromString<bool>       (const std::string& x)
   {
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Log2.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Log2.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Log2.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Log2
-#define morpheo_Log2
+#ifndef Morpheo_Log2_h
+#define Morpheo_Log2_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Max.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Max.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Max.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_max
-#define morpheo_max
+#ifndef Morpheo_Max_h
+#define Morpheo_Max_h
 
 /*
@@ -13,16 +13,48 @@
 namespace morpheo {
 
-  template<typename T> inline T max (const T * x, uint32_t size)
+  template<typename T> inline T max (T * x, uint32_t size)
   {
     T res = x[0];
 
     for (uint32_t i=1; i<size; i++)
-      if (res<x[i])
-	res = x[i];
+      {
+	T tmp = x[i];
+	if (res<tmp)
+	  res = tmp;
+      }
 
     return res;
   }
 
-  template<typename T> inline T max (const T * x, uint32_t size, uint32_t n)
+  template<typename T> inline T max (T ** x, uint32_t size1, uint32_t size2)
+  {
+    T res = max(x[0],size2);
+
+    for (uint32_t i=1; i<size1; i++)
+      {
+	T tmp = max(x[i],size2);
+	if (res<tmp)
+	  res = tmp;
+      }
+
+    return res;
+  }
+
+  template<typename T> inline T max (T ** x, uint32_t size1, uint32_t * size2)
+  {
+    T res = max(x[0],size2[0]);
+
+    for (uint32_t i=1; i<size1; i++)
+      {
+	T tmp = max(x[i],size2[i]);
+	if (res<tmp)
+	  res = tmp;
+      }
+
+    return res;
+  }
+
+
+  template<typename T> inline T max (T * x, uint32_t size, uint32_t n)
   {
     if ((n==0) or (n>size))
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Message.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Message.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Message.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef MESSAGE_H
-#define MESSAGE_H
+#ifndef Morpheo_Message_h
+#define Morpheo_Message_h
 /*
  * $Id$
@@ -15,20 +15,87 @@
 namespace morpheo {
 
-#define MSG_ERROR         _("[   ERROR   ]")
-#define MSG_WARNING       _("[  WARNING  ]")
-#define MSG_INFORMATION   _("[INFORMATION]")
+  // Color
+  // 31 : rouge
+  // 32 : vert
+  // 33 : jaune
+  // 34 : bleu
+  // 35 : rose
+  // 36 : cyan
+  // 37 : blanc
+  // 38 : noir souligne
+  // 39 : noir
 
-#define msg(arg...)				\
+#  define MSG_NONE          _("             ")
+#ifdef PRINT_COLOR
+#  define MSG_DEBUG         _("[1;34m[   DEBUG   ][0m")
+#  define MSG_ERROR         _("[1;31m[   ERROR   ][0m")
+#  define MSG_WARNING       _("[1;35m[  WARNING  ][0m")
+#  define MSG_INFORMATION   _("[1;32m[INFORMATION][0m")
+#  define MSG_BREAKPOINT    _("[1;38m[   BREAK   ][0m")
+#else
+#  define MSG_DEBUG         _("[   DEBUG   ]")
+#  define MSG_ERROR         _("[   ERROR   ]")
+#  define MSG_WARNING       _("[  WARNING  ]")
+#  define MSG_INFORMATION   _("[INFORMATION]")
+#  define MSG_BREAKPOINT    _("[   BREAK   ]")
+#endif
+
+#ifdef LOG_FILE
+extern FILE * log_stream;
+void log_init (void);
+
+#define fmsg(stream,arg...)			\
   do						\
     {						\
-      fprintf(stdout,arg);			\
+      log_init();                               \
+      fprintf(log_stream,arg);			\
+      fflush(log_stream);                       \
+    } while (0)
+
+#else
+
+#define fmsg(stream,arg...)			\
+  do						\
+    {						\
+      fprintf(stream,arg);			\
+      fflush(stream);                           \
     } while (0) 
 
-#define err(arg...)				\
+#endif
+
+#define fmsgDebug(stream,arg...)		\
   do						\
     {						\
-      fprintf(stderr,arg);			\
+      fmsg(stream,"%s ",MSG_DEBUG);             \
+      fmsg(stream,arg);			        \
     } while (0) 
 
+#define fmsgError(stream,arg...)		\
+  do						\
+    {						\
+      fmsg(stream,"%s ",MSG_ERROR);             \
+      fmsg(stream,arg);			        \
+    } while (0) 
+
+#define fmsgWarning(stream,arg...)		\
+  do						\
+    {						\
+      fmsg(stream,"%s ",MSG_WARNING);           \
+      fmsg(stream,arg);			        \
+    } while (0) 
+
+#define fmsgInformation(stream,arg...)		\
+  do						\
+    {						\
+      fmsg(stream,"%s ",MSG_INFORMATION);       \
+      fmsg(stream,arg);			        \
+    } while (0) 
+
+#define msg(arg...)		fmsg(stdout,arg)
+#define msgDebug(arg...)	fmsgDebug(stdout,arg)
+#define msgError(arg...)	fmsgError(stdout,arg)
+#define msgWarning(arg...)	fmsgWarning(stdout,arg)
+#define msgInformation(arg...)	fmsgInformation(stdout,arg)
+#define err(arg...)             fmsgError(stderr,arg)
 
 }; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Percent.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Percent.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Percent.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Percent
-#define morpheo_Percent
+#ifndef Morpheo_Percent_h
+#define Morpheo_Percent_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Test.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Test.h	(revision 88)
@@ -1,4 +1,12 @@
-#ifndef TEST_H
-#define TEST_H
+#ifndef Morpheo_Test_h
+#define Morpheo_Test_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Macro / function to test
+ */
 
 #include <iostream>
@@ -11,5 +19,6 @@
 namespace morpheo {
 
-//-----[ Routine de test ]---------------------------------------
+#define STR_OK "Test OK"
+#define STR_KO "Test KO"
 
 static uint32_t num_test;
@@ -24,5 +33,8 @@
 inline void test_ko (char * file, uint32_t line, T exp1, T exp2)
 {
-  std::cerr << "[" << num_test << "] : Test KO"
+  fflush (stdout);
+  fflush (stderr);
+
+  std::cerr << "[" << num_test << "] : " << STR_KO
        << "\tline " << line                      << std::endl
        << " * Localisation"                      << std::endl
@@ -38,5 +50,8 @@
 inline void test_ko (char * file, uint32_t line)
 {
-  std::cerr << "[" << num_test << "] : Test KO"
+  fflush (stdout);
+  fflush (stderr);
+
+  std::cerr << "[" << num_test << "] : " << STR_KO
        << "\tline " << line                           << std::endl
        << " * Localisation"                           << std::endl
@@ -49,5 +64,8 @@
 inline void test_ok ()
 {
-  msg (_("[%d] : Test OK\n"), num_test);
+  fflush (stdout);
+  fflush (stderr);
+
+  msg (_("[%d] : %s\n"), num_test,STR_OK);
 
   num_test ++;
@@ -56,5 +74,8 @@
 inline void test_ok (char * file, uint32_t line)
 {
-  msg (_("[%d] : Test OK\n"), num_test);
+  fflush (stdout);
+  fflush (stderr);
+
+  msg (_("[%d] : %s\n"), num_test,STR_OK);
   msg (_("\tline %d\n"), line);
 
@@ -65,5 +86,8 @@
 inline void test_ok (char * file, uint32_t line, T exp)
 {
-  msg (_("[%d] : Test OK\n"), num_test);
+  fflush (stdout);
+  fflush (stderr);
+
+  msg (_("[%d] : %s\n"), num_test, STR_OK);
   msg (_("\tline %d\n"), line);
   msg (_("\tvalue %s\n"), (morpheo::toString(exp)).c_str());
@@ -91,6 +115,6 @@
     msg (str);								\
     msg (_("\n"));							\
+    fflush (stdout);                                                    \
   } while(0)
-
 
 #ifndef CYCLE_MAX
@@ -109,5 +133,5 @@
 	}								\
       									\
-      if (cycle_current > CYCLE_MAX)					\
+      if ((CYCLE_MAX != 0) and (cycle_current > CYCLE_MAX))             \
 	{								\
 	  TEST_KO("Maximal cycles Reached");				\
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef TIME_H
-#define TIME_H
+#ifndef Morpheo_Time_h
+#define Morpheo_Time_h
 
 #ifdef SYSTEMC
@@ -10,14 +10,22 @@
 #include <sys/time.h>
 
+namespace morpheo {
+
 class Time 
 {
-private : timeval time_begin;
+#ifdef SYSTEMC
+private : double   nb_cycles_begin;
+#endif
+private : timeval  time_begin;
 // private : timeval time_end;
   
 public  : Time ()
-  {
-    gettimeofday(&time_begin     ,NULL);
+  { 
+#ifdef SYSTEMC
+    nb_cycles_begin = sc_simulation_time();
+#endif
+    gettimeofday(&time_begin,NULL);
   };
-
+  
 public  : ~Time ()
   {
@@ -25,20 +33,27 @@
   };
 
-public  : friend std::ostream& operator<< (std::ostream& output_stream,
+public  : friend std::ostream& operator<< (std::ostream& output,
 					   const Time & x)
   {
     timeval time_end;
     
-    gettimeofday(&time_end       ,NULL);
+    gettimeofday(&time_end,NULL);
     
-    uint32_t nb_cycles = static_cast<uint32_t>(sc_simulation_time());
-
-    double average = static_cast<double>(nb_cycles) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec+1);
+#ifdef SYSTEMC
+    double nb_cycles_end = sc_simulation_time();
+    double average       = static_cast<double>(nb_cycles_end-x.nb_cycles_begin+1) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec+1);
     
-    output_stream << "Timing : " << nb_cycles << " cycles \t(" << average << " cycles/s)" << std::endl;
-
-    return output_stream;
+    output << "Timing : " << nb_cycles_end << " cycles \t(" << average << " cycles/s)" << std::endl;
+#else
+    double average       = static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec+1);
+    
+    output << "Timing : " average << " s" << std::endl;
+#endif
+    
+    return output;
   }
 };
 
+}; // end namespace morpheo
+
 #endif
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/ToBase2.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/ToBase2.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/ToBase2.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_ToBase2
-#define morpheo_ToBase2
+#ifndef Morpheo_ToBase2_h
+#define Morpheo_ToBase2_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/ToString.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/ToString.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/ToString.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_tostring
-#define morpheo_tostring
+#ifndef Morpheo_ToString_h
+#define Morpheo_ToString_h
 
 /*
Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Translation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Translation.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Translation.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Translation_H
-#define morpheo_Translation_H
+#ifndef Morpheo_Translation_h
+#define Morpheo_Translation_h
 /*
  * $Id$
@@ -16,18 +16,13 @@
 #define MORPHEO_PACKAGE "morpheo"
 
-#ifdef NO_TRANSLATION
+#ifdef TRANSLATION
+# define _(str) dgettext (MORPHEO_PACKAGE,str)
+#else
 # define _(str) (str)
-#else
-# define _(str) dgettext (MORPHEO_PACKAGE,str)
 #endif
 
 namespace morpheo 
 {
-  class Translation
-  {
-  public :  Translation (void);
-  public : ~Translation (void);
-  };
-
+  void translation (void);
 }; // end namespace morpheo
 #endif
